
/********************************************************************************
 *										*
 *				 M A C E K					*
 *		("Matroids Also Computed Efficiently" Kit)			*
 *										*
 * A set of tools and routines for computations with representable matroids.	*
 * Copyright (C) 2001,2002  Petr Hlineny.					*
 *										*
 *   This program is free software; you can redistribute it and/or modify	*
 *   it under the terms of the GNU General Public License as published by	*
 *   the Free Software Foundation; either version 2 of the License, or		*
 *   (at your option) any later version.					*
 *   You should have received a copy of the GNU General Public License		*
 *   along with this program; if not, write to the Free Software		*
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.	*
 * 										*
 * See the top-level "ABOUT" and "doc/ *" files for more information.		*
 *										*
 ********************************************************************************/














/**
 * Some theory for start...
 * 
 * This part contains fuctions for "structural work" with represented matroids.
 * (We do not attempt to work with matroids without a matrix representation - too complicated.)
 * Read ematrix.h to learn about our matrices, and pfield.h about our pfield arithmetic.
 * Read ../include/struct.h for more information about these structural functions...
 * 
 * 
**/



#ifndef STR_H 
#define STR_H 








/******************	Matrix automorphisms and minors	*******************/
/**************************************************************************/


/**
 * 
 * 
 * supplements for automorphisms.......
**/

int             struct_autom_linehash(ematrix *e, int un, long hashr[], long hashc[],
					long *hashrr[], long *hashcc[]) ;
emxaut**	struct_autom_rowf(int ch, ematrix *e, int un, int pr[],
					long hashc[], long *hashcc[], emxaut **aout) ;

int	struct_fitcols(int init, ematrix *efr, ematrix *eto, int un,
		long hscfr[], long hscto[], long *hsccfr[], long *hsccto[],
		int pcm[], exp_t xr[], sign_t gr[], exp_t xc[], sign_t gc[], void **pdata) ;



/**
 * 
 * 
 * supplements for bases and dispminors........
**/

ematrix**	struct_allbases_recur(int ch, ematrix *e, ematrix *re, int dr, int dc, ematrix **bout) ;

ematrix**	struct_dispminor_core(int ch, ematrix *e, ematrix *emin, ematrix **mout) ;
ematrix**	struct_dispminor_rowfix(int ch, ematrix *em, ematrix *eb, long hcm[], long hcb[],
					int prm[], long cmpat[], emxaut **arow, ematrix **mout) ;

int             struct_dispminor_rowhash(int ch, ematrix *em, ematrix *eb, long hsm[], long hsb[],
						void *hspt) ;
void		struct_dispminor_linedet(ematrix *ee, int tr, int r1, int r2, int ar[]) ;
void		struct_dispminor_fitldet(int cm, long zm1, long zm2, int *zpm[],
				int cb, long zb1, long zb2, int *zpb[], long ih[]) ;

		/* macros for access to quadruple-indexed hash-values for mapping pairs of rows - see ..rowhash() */
#define	STR_MAXABSVALIX	2	/* (the max number of multiplicative endomorphisms used) */
#define IHSETVARACCESS(em,eb)	long  *pti; \
				int   rbi=ROWSM(eb), rmi=ROWSM(em),cmi=COLSM(em)
#define IHGETPOINTER		pti
#define IHGETSIZE		((rmi)*(rmi)*(rbi)*(rbi)*(cmi))
#define IHGET(rm1,rm2,rb1,rb2)	((pti)+((((rm1)*rmi+(rm2))*rbi+(rb1))*rbi+(rb2))*(cmi))


extern FILE    *struct_printdispm;              /* request to print the displayed minors to the file */
extern char    *struct_printdispp;              /*  prefix for the print request */




/**
 * 
 * 
 * supplements for 3-separations......
**/

int     struct_hasfan_triax(int ch, ematrix *e, int trt, int l1, int l2, int l3, int nps) ;

int     struct_hastail3_core(int ch, ematrix *ee, ematrix *re, int tail, int tmod) ;

int     struct_hasbwidth3_separe(ematrix *e, ematrix *rr, ematrix **pol[], int k) ;
ematrix*     struct_hasbwidth3_cycled(ematrix *e, ematrix **plist, ematrix **pol[], int k) ;

















#endif	/* (of #ifndef STR_H) */























